import * as React from 'react';
import React__default, { useRef, useMemo, useState, useCallback, useEffect, forwardRef, useImperativeHandle } from 'react';
import { Mind } from 'bade-mind';
export { Mind } from 'bade-mind';
import Classnames from 'classnames';
import * as D3 from 'd3';

const classNameWrapper=(s,a)=>Classnames(s[a],`mind-react__${a}`);

function styleInject(e,t){void 0===t&&(t={});var d=t.insertAt;if(e&&"undefined"!=typeof document){var n=document.head||document.getElementsByTagName("head")[0],s=document.createElement("style");s.type="text/css","top"===d&&n.firstChild?n.insertBefore(s,n.firstChild):n.appendChild(s),s.styleSheet?s.styleSheet.cssText=e:s.appendChild(document.createTextNode(e));}}

var css_248z$1=".index-module_axis__Eb7Ns {\n  position: absolute; }\n  .index-module_axis__Eb7Ns .index-module_thumb__8n-J0 {\n    position: absolute;\n    left: 0;\n    top: 0;\n    border-radius: 4px;\n    background: #c4cbcf; }\n    .index-module_axis__Eb7Ns .index-module_thumb__8n-J0:hover {\n      background: #7a7374; }\n  .index-module_axis--active__KZOxZ .index-module_thumb__8n-J0 {\n    background: #7a7374; }\n  .index-module_axis--y__85kyh {\n    right: 0;\n    top: 0;\n    height: 100%;\n    width: 8px; }\n    .index-module_axis--y__85kyh .index-module_thumb__8n-J0 {\n      width: 100%; }\n  .index-module_axis--x__btlgk {\n    left: 0;\n    bottom: 0;\n    width: 100%;\n    height: 8px; }\n    .index-module_axis--x__btlgk .index-module_thumb__8n-J0 {\n      height: 100%; }\n";var Style$1 = {axis:"index-module_axis__Eb7Ns",thumb:"index-module_thumb__8n-J0","axis--active":"index-module_axis--active__KZOxZ","axis--y":"index-module_axis--y__85kyh","axis--x":"index-module_axis--x__btlgk"};styleInject(css_248z$1);

const Axis=e=>{const{total:t,thumb:a,value:s,onChange:r,vertical:o}=e,n=useRef(null),l=useMemo((()=>t+a),[t,a]),u=useMemo((()=>a*a/l),[a,l]),c=useMemo((()=>s*a/l),[s,a,l]),[i,m]=useState(!1),p=useRef(),f=useMemo((()=>{const e={};return o?(e.height=`${u}px`,e.transform=`translateY(${c}px)`):(e.width=`${u}px`,e.transform=`translateX(${c}px)`),e}),[u,c,o]),v=useCallback((e=>{e<0?e=0:e>1-u/a&&(e=1-u/a),r(e*l/t);}),[r,t,l]),d=useCallback((e=>{if(e.target===n.current){let t=0;t=o?(e.nativeEvent.offsetY-u/2)/a:(e.nativeEvent.offsetX-u/2)/a,v(t);}e.stopPropagation();}),[a,u,v]),x=useCallback((e=>{if(!i)return;p.current||(p.current={absolute:0,relative:0},p.current.relative=c,p.current.absolute=o?e.clientY:e.clientX);let t=0;t=o?e.clientY:e.clientX;const s=t-p.current.absolute+p.current.relative;v(s/a),e.stopPropagation();}),[v,i,c,o,a]);return useEffect((()=>(window.addEventListener("mousemove",x),()=>window.removeEventListener("mousemove",x))),[x]),useEffect((()=>{const e=e=>{m(!1),p.current=void 0,e.stopPropagation();};return window.addEventListener("mouseup",e),()=>window.removeEventListener("mouseup",e)}),[m]),React.createElement("div",{className:Classnames(classNameWrapper(Style$1,"axis"),classNameWrapper(Style$1,o?"axis--y":"axis--x"),i?classNameWrapper(Style$1,"axis--active"):""),onClick:d,ref:n},React.createElement("div",{className:classNameWrapper(Style$1,"thumb"),style:f,onMouseDown:e=>(m(!0),e.preventDefault(),e.stopPropagation(),!1)}))};

const Scrollbar=e=>{const{viewport:t,container:i,mind:a,transform:n,options:s}=e,[h,m]=useState({x:{max:0,min:0},y:{max:0,min:0}}),[r,c]=useState({height:0,width:0}),[x,o]=useState({height:0,width:0});return useEffect((()=>{if(t&&i){const e=new ResizeObserver((()=>{c({height:t.clientHeight,width:t.clientWidth}),o({height:i.clientHeight,width:i.clientWidth});}));return e.observe(t),e.observe(i),()=>{e.unobserve(t),e.unobserve(i);}}}),[t,i]),useEffect((()=>{x.width&&r.width&&n&&a&&(a.setOptions({zoomExtent:{translate:[{x:-r.width/n.scale,y:-r.height/n.scale},{x:x.width+r.width/n.scale,y:x.height+r.height/n.scale}]}},!0),m({x:{max:r.width,min:-x.width*n.scale},y:{max:r.height,min:-x.height*n.scale}}));}),[x,r,s,n,a]),t&&i&&a&&n&&x.width&&r.width?React__default.createElement(React__default.Fragment,null,React__default.createElement(Axis,{total:h.x.max-h.x.min,thumb:r.width,value:h.x.max-n.x,onChange:e=>{a&&a.setTransform(Object.assign(Object.assign({},a.getTransform()),{x:h.x.max-(h.x.max-h.x.min)*e}));},vertical:!1}),React__default.createElement(Axis,{total:h.y.max-h.y.min,thumb:r.height,value:h.y.max-n.y,onChange:e=>{a&&a.setTransform(Object.assign(Object.assign({},a.getTransform()),{y:h.y.max-(h.y.max-h.y.min)*e}));},vertical:!0})):React__default.createElement(React__default.Fragment,null)};

const useShadowState=e=>{const[t,u]=useState(e),r=useRef(t);return [t,useCallback((e=>{let t=e;"function"==typeof e&&(t=e(r.current)),r.current=t,u(t);}),[]),r]};

const useDrag=r=>{const{mind:e,draggableNodeWrapperQualifier:t,nodeWrapperClassName:n,nodesContainer:i,onDrag:o,onDragEnd:a,onDragStart:d,sizeof:c,renderNodes:s,data:u,renderChangeToggle:g}=r,[h,l,x]=useShadowState(void 0),[f,p,y]=useShadowState(void 0),v=useRef(void 0),[m,S,w]=useShadowState({x:0,y:0}),[D,N]=useState(!1),z=useRef({origin:{x:0,y:0},size:{height:0,width:0},start:{x:0,y:0}}),b=useRef(void 0);return useEffect((()=>{e&&i&&D3.select(i).selectAll(t).call(D3.drag().on("start",(r=>{const t=r.sourceEvent.path.find((r=>r.className.includes(n)));if(t){const n=t.getAttribute("data-node-id"),i=e.getNodeAnchorCoordinate(n),o=c(n);i&&(z.current.start.x=r.x,z.current.start.y=r.y,z.current.origin.x=i.x,z.current.origin.y=i.y,S({x:i.x,y:i.y})),o&&(z.current.size.width=o.width,z.current.size.height=o.height);const a=e.getNode(n);a&&(d&&d({node:a}),l(a),v.current=e.dragControllerBuilder(n));}})).on("drag",(r=>{if(v.current){const t=e.getTransform().scale,n={x:(r.x-z.current.start.x)/t,y:(r.y-z.current.start.y)/t},i={x:n.x+z.current.origin.x+z.current.size.width/2,y:n.y+z.current.origin.y+z.current.size.height/2};S({x:n.x+z.current.origin.x,y:n.y+z.current.origin.y});const a=v.current.drag(Object.assign({},i),s.filter((r=>void 0===r.droppable||r.droppable)));b.current=null==a?void 0:a.orientation,o&&o({attach:a&&a.attach&&a.orientation?{orientation:a.orientation,parent:a.attach}:void 0,mirrorPosition:Object.assign({},i),node:x.current}),N(!0),p(null==a?void 0:a.attach);}})).on("end",(()=>{if(v.current){const r=y.current;let t=-1;if(r){let e=r.children;r.id===u.node.id&&(e=b.current===Mind.Orientation.positive?u.positive:u.negative),t=v.current.calcDropIndex(e,{x:w.current.x+z.current.size.width/2,y:w.current.y+z.current.size.height/2},x.current,r);}v.current.end(),v.current=void 0,a&&a({attach:y.current&&b.current?{index:t,orientation:b.current,parent:y.current}:void 0,node:x.current,original:{orientation:e.getNodeOrientation(x.current.id),parent:e.getParent(x.current.id)}});}l(void 0),p(void 0),N(!1),b.current=void 0;})));}),[e,g,u,s,d,o,a,i]),{dragAttachedNode:f,dragMirrorPosition:m,dragNode:h,isInDragging:D}};

var css_248z=".index-module_viewport__N4lZq, .index-module_root__Xae4b {\n  width: 100%;\n  height: 100%;\n  position: relative;\n  overflow: hidden; }\n\n.index-module_viewport--drag-move__J0kiC {\n  cursor: pointer; }\n\n.index-module_container__mw-kv {\n  position: relative; }\n\n.index-module_nodes__8dI61 {\n  position: relative; }\n\n.index-module_node-wrapper__-Sf2T {\n  position: absolute;\n  top: 0;\n  left: 0; }\n\n.index-module_drag-mirror-node__5DoQZ {\n  cursor: pointer; }\n\n.index-module_temporary-line__fOjbL {\n  position: absolute;\n  pointer-events: none; }\n\n.index-module_node-wrapper--dragging__sU6vb > * {\n  outline: 2px solid #c04851; }\n\n.index-module_node-wrapper--attached__LgiGr > * {\n  outline: 2px solid #2775b6; }\n\n.index-module_drag-mirror-node__5DoQZ {\n  opacity: 0.6; }\n  .index-module_drag-mirror-node__5DoQZ > * {\n    outline: 2px solid #2775b6; }\n\n.bade-mind__lines {\n  stroke: #2775b6;\n  stroke-width: 3px; }\n\n.bade-mind__temporary-line {\n  opacity: 0.6; }\n";var Style = {viewport:"index-module_viewport__N4lZq",root:"index-module_root__Xae4b","viewport--drag-move":"index-module_viewport--drag-move__J0kiC",container:"index-module_container__mw-kv",nodes:"index-module_nodes__8dI61","node-wrapper":"index-module_node-wrapper__-Sf2T","drag-mirror-node":"index-module_drag-mirror-node__5DoQZ","temporary-line":"index-module_temporary-line__fOjbL","node-wrapper--dragging":"index-module_node-wrapper--dragging__sU6vb","node-wrapper--attached":"index-module_node-wrapper--attached__LgiGr"};styleInject(css_248z);

const Nodes=e=>{const{mind:a,data:r,render:t,renderChangeToggle:d,onDrag:i,onDragEnd:s,onDragStart:n}=e,o=useRef(new Map),[l,p]=useState(null),g=useMemo((()=>{if(r){const e=new Map(o.current);return o.current=new Map,Mind._Helper.rootToNodeArray(r,(a=>{e.has(a.id)?o.current.set(a.id,e.get(a.id)):o.current.set(a.id,{size:{height:-1,width:-1},updateToDate:!1});}))}return []}),[r]),m=useCallback((e=>{var a;return null===(a=o.current.get(e))||void 0===a?void 0:a.size}),[]),{isInDragging:c,dragNode:u,dragMirrorPosition:h,dragAttachedNode:y}=useDrag({data:r,draggableNodeWrapperQualifier:`.${Style["node-wrapper"]}[data-node-draggable="true"]:not(.${Style["drag-mirror-node"]})`,mind:a,nodeWrapperClassName:Style["node-wrapper"],nodesContainer:l,onDrag:i,onDragEnd:s,onDragStart:n,renderChangeToggle:d,renderNodes:g,sizeof:m}),z=useMemo((()=>g.map((e=>{const d=(null==a?void 0:a.getNodeAnchorCoordinate(e.id))||{x:0,y:0},i=(null==a?void 0:a.judgeNodeVisible(e.id))||e.alwaysVisible,s=o.current.get(e.id);let n=!s.updateToDate||s.size.width<0||e.disableSizeCache||e.needUpdateSize;e.size&&(n=!1,s.size.width=e.size.width,s.size.height=e.size.height),n||(e.sizeof=()=>({height:s.size.height,width:s.size.width}));const l=i||e.beProtected||n,p=!!e.draggable&&e.id!==r.node.id;return l&&React.createElement("div",{key:e.id,className:Classnames(classNameWrapper(Style,"node-wrapper"),{[classNameWrapper(Style,"node-wrapper--dragging")]:e.id===(null==u?void 0:u.id)&&c,[classNameWrapper(Style,"node-wrapper--attached")]:e.id===(null==y?void 0:y.id)&&c}),style:{transform:`translateX(${d.x}px) translateY(${d.y}px)`,visibility:i?"visible":"hidden"},"data-node-id":String(e.id),"data-node-draggable":String(p),ref:a=>{a&&n&&(s.updateToDate=!0,s.size.width=a.clientWidth,s.size.height=a.clientHeight,e.sizeof=()=>s.size,e.needUpdateSize=!1);}},t(e,!1))}))),[a,g,d,t,u,y,c]);return React.createElement("div",{className:classNameWrapper(Style,"nodes"),ref:p},z,u&&c&&React.createElement("div",{className:Classnames(classNameWrapper(Style,"node-wrapper"),classNameWrapper(Style,"drag-mirror-node")),style:{transform:`translateX(${h.x}px) translateY(${h.y}px)`}},t(u,!0)))};

const View=forwardRef(((e,a)=>{const{className:t,style:s,options:r,data:n,anchor:o,render:l,onUpdated:c,scrollbar:m,wheelMoveSpeed:i=.5,onDragEnd:d,onDragStart:u,onDrag:f}=e,[p,v]=useState(),[b,g]=useState(),[E,S]=useState(),[w,N]=useState(),[y,C]=useState(!1),[h,R]=useState(0),k=useRef(c);useImperativeHandle(a,(()=>({mind:p})),[p]),useEffect((()=>{k.current=c;}),[c]),useEffect((()=>()=>{p&&p.unbind();}),[p]);const D=useCallback((e=>{N((a=>e.x===(null==a?void 0:a.x)&&e.y===(null==a?void 0:a.y)&&e.scale===(null==a?void 0:a.scale)?a:Object.assign({},e)));}),[]),M=useCallback((e=>{R((e=>e+1));}),[]),x=useCallback((e=>{e&&"mousedown"===e.type&&C(!0);}),[]),O=useCallback((e=>{e&&"mouseup"===e.type&&C(!1);}),[]),T=useMemo((()=>{const e=Object.assign({},r||{});e.callback=Object.assign({},e.callback||{}),e.event=Object.assign({},e.event||{});const{onZoomEventTrigger:{start:a,zoom:t,end:s}={}}=e.event,{onTransformChange:n,onNodeVisibleChange:o}=e.callback;return e.callback.onTransformChange=e=>{D(e),n&&n(e);},e.callback.onNodeVisibleChange=e=>{M(e),o&&o(e);},e.event.onZoomEventTrigger={end:e=>{s&&s(e),O(e);},start:e=>{a&&a(e),x(e);},zoom:e=>t&&t(e)},e}),[r,D,M,x,O]);return useEffect((()=>{b&&E&&v(new Mind.Graphic(b,E));}),[b,E]),useEffect((()=>{p&&p.setAnchor(o);}),[p,o]),useEffect((()=>{p&&n&&(p.setOptions(T),p.setData(n),k.current&&k.current(p));}),[p,n,T]),useEffect((()=>{null==p||p.refresh();}),[l]),useEffect((()=>{if(b){const e=e=>{e.preventDefault(),p&&p.translate({x:-e.deltaX*i,y:-e.deltaY*i});};return b.addEventListener("wheel",e,{passive:!1}),()=>b.removeEventListener("wheel",e)}}),[b,p,i]),React__default.createElement("div",{className:Classnames(classNameWrapper(Style,"root"),t)},React__default.createElement("div",{className:Classnames(classNameWrapper(Style,"viewport"),{[classNameWrapper(Style,"viewport--drag-move")]:y}),style:s,ref:g},React__default.createElement("div",{className:classNameWrapper(Style,"container"),ref:S},React__default.createElement(Nodes,{mind:p,onDragEnd:d,onDragStart:u,onDrag:f,data:n,render:l,renderChangeToggle:h}))),m&&React__default.createElement(Scrollbar,{viewport:b,container:E,mind:p,transform:w,options:T}))}));View.displayName="MindReact.View";

var MindReact;!function(e){e.View=View;}(MindReact||(MindReact={}));

export { MindReact };
